#pragma once
#include <fstream>

template <typename Output>
struct SDay {
	std::string name;
	std::ifstream input;

	//Constructor and Destructor
	SDay(std::string);
	~SDay();

	virtual Output part1() const = 0;
	virtual Output part2() const = 0;
};

template <typename Output>
SDay<Output>::SDay(std::string name) {
	this->name = name;
	input.open("input/" + name, std::ios::in);
}

template <typename Output>
SDay<Output>::~SDay() {
	input.close();
}

